#include<stdio.h>

/*
Funkcija zaba daje tocno rjesenje zadatka.
Nije se mijenjala u odnosu na ono sto se napravilo
na satu.
*/
int zaba(int n, int k, int br)
{
    int i=0, j;

    if(k<0 || k>n)
        return 0;
    if(br>17)
        return 0;
    if(k==n)
        return 1;

    for(j=2; j<=3; j++)
        i+=zaba(n,k-j,br+1)+zaba(n,k+j,br+1);

    return i;
}


/*
Funkcija zaba2 NE DAJE tocan rezultat!
Zapravo pokusaj da se varijabla br izostavi
iz argumenta funkcije i postavi kao static
nije dobra jer se pri svakom pozivu funkcije
br povecava za jedan sto nije naravno dobro
(tako nesto je i komentirano na vjezbama da
 bi moglo stvarati problem).

Vec za n=3 smo primjetili da funkcija ne radi
dobro. Proslogodisnja funkcija je radila dobro
za n=3 iz puke slucajnosti. Naime, ako se
uvijet za vracanje jedinice stavi na sam pocetak
(trenutno zakomentiran dolje) onda ce funkcija
vratiti 1 i u slucaju da je br>17. S ovom modifikacijom
radi program samo u slucaju da su sva rjesenja oblika
+2-2+2-2+...+2-2+(2 ili 3), a to imamo u slucaju
n=2 i n=3, dok vec za n=4 to nije slucaj pa cemo
dobiti krivo rjesnje.
Ukratko, donje rjesenje NIJE DOBRO, ali malo analizirajte
program da naucite staticke varijable.
*/
int zaba2(int n, int k)
{
    int i=0, j;
    static int br=0;

//    if(k==n)
//        return 1;
    if(k<0 || k>n)
        return 0;
    if(br>17)
        return 0;
    if(k==n)
        return 1;

    br++;
    for(j=2; j<=3; j++){
        i+=zaba2(n,k-j)+zaba2(n,k+j);
    }

    return i;
}

int main(void)
{

    printf("Broj nacina dan prvom funkcijom je %d, a drugom %d.\n", zaba(4,0,0), zaba2(4,0));

    return 0;
}
